Thread (7 messages) flat view 7 messages, 2 authors, 2016-06-15

Re: [PATCH v2 4/4] contrib: add convert-grafts-to-replace-refs.sh

From: Eric Sunshine <hidden>
Date: 2016-06-15 23:01:26

On Sun, Jun 1, 2014 at 11:10 AM, Christian Couder
[off-list ref] wrote:
quoted hunk ↗ jump to hunk
This patch adds into contrib/ an example script to convert
grafts from an existing grafts file into replace refs using
the new --graft option of "git replace".

While at it let's mention this new script in the
"git replace" documentation for the --graft option.

Signed-off-by: Christian Couder <redacted>
---
diff --git a/contrib/convert-grafts-to-replace-refs.sh b/contrib/convert-grafts-to-replace-refs.sh
new file mode 100755
index 0000000..7718a53
--- /dev/null
+++ b/contrib/convert-grafts-to-replace-refs.sh
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+# You should execute this script in the repository where you
+# want to convert grafts to replace refs.
+
+die () {
+       echo >&2 "$@"
+       exit 1
+}
+
+GRAFTS_FILE="${GIT_DIR:-.git}/info/grafts"
+
+test -f "$GRAFTS_FILE" || die "Could not find graft file: '$GRAFTS_FILE'"
+
+grep '^[^# ]' "$GRAFTS_FILE" | while read definition
+do
+       test -n "$definition" && {
+               echo "Converting: $definition"
+               git replace --graft $definition ||
+                       die "Convertion failed for: $definition"
s/Convertion/Conversion/  [1]

[1]: http://git.661346.n2.nabble.com/Re-PATCH-contrib-add-convert-grafts-to-replace-refs-sh-tp7611822.html
+       }
+done
+
+mv "$GRAFTS_FILE" "$GRAFTS_FILE.bak" ||
+       die "Could not mv '$GRAFTS_FILE' to '$GRAFTS_FILE.bak'"
"Could not rename..." might be a bit more friendly to non-Unixy folk.
+echo "Success!"
+echo "All the grafts in '$GRAFTS_FILE' have been converted to replace refs!"
+echo "The grafts file '$GRAFTS_FILE' has been renamed: '$GRAFTS_FILE.bak'"
--
2.0.0.rc0.40.gd30ccc4
Keyboard shortcuts
hback out one level
jnext message in thread
kprevious message in thread
ldrill in
Escclose help / fold thread tree
?toggle this help